## openttd 14.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

if(NOT BINARY_NAME)
    set(BINARY_NAME openttd)
endif()

project(${BINARY_NAME}
    VERSION 14.0
    LANGUAGES CXX
)

if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
    message(FATAL_ERROR "In-source builds not allowed. Please run \"cmake ..\" from the build directory. You may need to delete \"${CMAKE_SOURCE_DIR}/CMakeCache.txt\" first.")
endif()

# Debug mode by default.
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Debug)
endif()

if (EMSCRIPTEN)
    set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/os/emscripten/cmake")
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake")
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.15)

# Use GNUInstallDirs to allow customisation
# but set our own default data and bin dir
if(NOT CMAKE_INSTALL_DATADIR)
    set(CMAKE_INSTALL_DATADIR "share/games")
endif()
if(NOT CMAKE_INSTALL_BINDIR)
    set(CMAKE_INSTALL_BINDIR "games")
endif()
include(GNUInstallDirs)

include(Options)
set_options()
set_directory_options()

include(Static)
set_static_if_needed()

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

set(CMAKE_EXPORT_COMPILE_COMMANDS YES)

# An empty target for the tools
add_custom_target(tools)

include(Endian)
add_endian_definition()

include(CompileFlags)
compile_flags()

if(APPLE OR UNIX)
    add_definitions(-DUNIX)
endif()

if(UNIX)
    find_package(Doxygen)
endif()

list(APPEND GENERATED_SOURCE_FILES "${CMAKE_BINARY_DIR}/generated/rev.cpp")
if(WIN32)
    list(APPEND GENERATED_SOURCE_FILES "${CMAKE_BINARY_DIR}/generated/ottdres.rc")
endif()

# Generate a target to determine version, which is execute every 'make' run
add_custom_target(find_version
        ${CMAKE_COMMAND}
                -DFIND_VERSION_BINARY_DIR=${CMAKE_BINARY_DIR}/generated
                -DCPACK_BINARY_DIR=${CMAKE_BINARY_DIR}
                -DREV_MAJOR=${PROJECT_VERSION_MAJOR}
                -DREV_MINOR=${PROJECT_VERSION_MINOR}
                -DWINDOWS=${WIN32}
                -P "${CMAKE_SOURCE_DIR}/cmake/scripts/FindVersion.cmake"
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        BYPRODUCTS ${GENERATED_SOURCE_FILES}
)

# Documentation
if(DOXYGEN_EXECUTABLE)
    add_custom_target(docs)
    add_custom_target(docs_source
        ${CMAKE_COMMAND} -E make_directory ${CMAKE_BINARY_DIR}/docs
        COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_BINARY_DIR}/Doxyfile
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        COMMENT "Generating documentation for source"
    )
    add_dependencies(docs_source
        find_version
    )
    add_dependencies(docs
        docs_source
    )
endif()

include(AddCustomXXXTimestamp)

if(OPTION_TOOLS_ONLY)
    if(HOST_BINARY_DIR)
        unset(HOST_BINARY_DIR CACHE)
    endif()
    add_subdirectory(${CMAKE_SOURCE_DIR}/src)
    return()
endif()

if(APPLE)
	# Avoid searching for headers in Frameworks, and libraries in LIBDIR.
	set(CMAKE_FIND_FRAMEWORK LAST)
endif()

# Prefer -pthread over -lpthread, which is often the better option of the two.
set(CMAKE_THREAD_PREFER_PTHREAD YES)
# Make sure we have Threads available.
find_package(Threads REQUIRED)

find_package(ZLIB)
find_package(LibLZMA)
find_package(LZO)
find_package(PNG)

if(WIN32 OR EMSCRIPTEN)
    # Windows uses WinHttp for HTTP requests.
    # Emscripten uses Javascript for HTTP requests.
else()
    # All other targets use libcurl.
    find_package(CURL)
endif()

# Breakpad doesn't support emscripten.
if(NOT EMSCRIPTEN)
    find_package(unofficial-breakpad)
endif()

if(NOT OPTION_DEDICATED)
    if(NOT WIN32)
        find_package(Allegro)
        if(NOT APPLE)
            find_package(Freetype)
            find_package(SDL2)
            if(NOT SDL2_FOUND)
                find_package(SDL)
            endif()
            find_package(Fluidsynth)
            if(Freetype_FOUND)
                find_package(Fontconfig)
            endif()
            find_package(Harfbuzz)
            find_package(ICU OPTIONAL_COMPONENTS i18n)
        endif()
    endif()
endif()
if(APPLE)
    enable_language(OBJCXX)

    find_package(Iconv)

    find_library(AUDIOTOOLBOX_LIBRARY AudioToolbox)
    find_library(AUDIOUNIT_LIBRARY AudioUnit)
    find_library(COCOA_LIBRARY Cocoa)
    find_library(QUARTZCORE_LIBRARY QuartzCore)
endif()

if(NOT EMSCRIPTEN AND NOT OPTION_DEDICATED)
    find_package(OpenGL COMPONENTS OpenGL)
endif()

if(MSVC)
    find_package(Editbin REQUIRED)
endif()

find_package(SSE)
find_package(Xaudio2)

find_package(Grfcodec)

include(CheckIPOSupported)
check_ipo_supported(RESULT IPO_FOUND)

show_options()

if(UNIX AND NOT APPLE AND NOT OPTION_DEDICATED)
    if(NOT SDL_FOUND AND NOT SDL2_FOUND AND NOT ALLEGRO_FOUND)
        message(FATAL_ERROR "SDL, SDL2 or Allegro is required for this platform")
    endif()
    if(HARFBUZZ_FOUND AND NOT ICU_i18n_FOUND)
        message(WARNING "HarfBuzz depends on ICU i18n to function; HarfBuzz will be disabled")
    endif()
    if(NOT HARFBUZZ_FOUND)
        message(WARNING "Without HarfBuzz and ICU i18n the game will not be able to render right-to-left languages correctly")
    endif()
endif()
if(APPLE)
    if(NOT AUDIOTOOLBOX_LIBRARY)
        message(FATAL_ERROR "AudioToolbox is required for this platform")
    endif()
    if(NOT AUDIOUNIT_LIBRARY)
        message(FATAL_ERROR "AudioUnit is required for this platform")
    endif()
    if(NOT COCOA_LIBRARY)
        message(FATAL_ERROR "Cocoa is required for this platform")
    endif()
    if(NOT QUARTZCORE_LIBRARY)
        message(FATAL_ERROR "QuartzCore is required for this platform")
    endif()
endif()

if(OPTION_PACKAGE_DEPENDENCIES)
    if(NOT UNIX)
        message(FATAL_ERROR "Can only package dependencies on Linux")
    endif()
    if(OPTION_INSTALL_FHS)
        message(FATAL_ERROR "Cannot install in FHS folders when we are packaging dependencies")
    endif()
    if(${CMAKE_VERSION} VERSION_LESS "3.16.0")
        message(FATAL_ERROR "OPTION_PACKAGE_DEPENDENCIES can only work with CMake 3.16+; you are using ${CMAKE_VERSION}")
    endif()

    # If we are packaging dependencies, we do two things:
    # 1) set the RPATH to include $ORIGIN/lib; $ORIGIN (that literal string)
    #    is a Linux indicator for "path where application is". In CMake, we
    #    have to do this before add_executable() is executed.
    # 2) copy the libraries that we compile against to the "lib" folder.
    #    This is done in InstallAndPackage.cmake.
    set(CMAKE_INSTALL_RPATH "\$ORIGIN/lib")
    set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()

include(CTest)
include(SourceList)

# Needed by rev.cpp
include_directories(${CMAKE_SOURCE_DIR}/src)
# Needed by everything that uses Squirrel
include_directories(${CMAKE_SOURCE_DIR}/src/3rdparty/squirrel/include)

include(MSVCFilters)

add_library(openttd_lib OBJECT ${GENERATED_SOURCE_FILES})
add_executable(openttd WIN32)
add_executable(openttd_test)
set_target_properties(openttd PROPERTIES OUTPUT_NAME "${BINARY_NAME}")
# All other files are added via target_sources()

if(MSVC)
    # Add DPI manifest to project; other WIN32 targets get this via ottdres.rc
    target_sources(openttd PRIVATE "${CMAKE_SOURCE_DIR}/os/windows/openttd.manifest")

    # If target -static is used, switch our project to static (/MT) too.
    # If the target ends on -static-md, it will remain dynamic (/MD).
    if(VCPKG_TARGET_TRIPLET MATCHES "-static" AND NOT VCPKG_TARGET_TRIPLET MATCHES "-md")
        set_property(TARGET openttd_lib PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
        set_property(TARGET openttd PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
        set_property(TARGET openttd_test PROPERTY MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
     endif()
endif()

target_precompile_headers(openttd_lib
    PRIVATE
    src/stdafx.h
    src/core/format.hpp
)

add_subdirectory(${CMAKE_SOURCE_DIR}/bin)
add_subdirectory(${CMAKE_SOURCE_DIR}/src)
add_subdirectory(${CMAKE_SOURCE_DIR}/media)

add_dependencies(openttd
    find_version)

target_link_libraries(openttd_lib
    openttd::languages
    openttd::settings
    openttd::script_api
    Threads::Threads
)

target_link_libraries(openttd
    openttd_lib
    openttd::media
    openttd::basesets
)

target_link_libraries(openttd_test PRIVATE openttd_lib)
if(ANDROID)
    target_link_libraries(openttd_test PRIVATE log)
endif()

include(Catch)
catch_discover_tests(openttd_test)

if(HAIKU)
    target_link_libraries(openttd_lib "be" "network" "midi")
endif()

if(IPO_FOUND)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_RELEASE True)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_MINSIZEREL True)
    set_target_properties(openttd PROPERTIES INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO True)
endif()
set_target_properties(openttd PROPERTIES VS_DEBUGGER_WORKING_DIRECTORY "${CMAKE_BINARY_DIR}")
process_compile_flags()

include(LinkPackage)
link_package(PNG TARGET PNG::PNG ENCOURAGED)
link_package(ZLIB TARGET ZLIB::ZLIB ENCOURAGED)
link_package(LIBLZMA TARGET LibLZMA::LibLZMA ENCOURAGED)
link_package(LZO)

if(NOT WIN32 AND NOT EMSCRIPTEN)
    link_package(CURL ENCOURAGED)
    target_link_libraries(openttd_lib ${CMAKE_DL_LIBS})
endif()

if(NOT EMSCRIPTEN)
    link_package(unofficial-breakpad TARGET unofficial::breakpad::libbreakpad_client ENCOURAGED)
endif()

if(NOT OPTION_DEDICATED)
    link_package(Fluidsynth)
    link_package(SDL)
    link_package(SDL2 TARGET SDL2::SDL2)
    link_package(Allegro)
    link_package(FREETYPE TARGET Freetype::Freetype)
    link_package(Fontconfig TARGET Fontconfig::Fontconfig)
    link_package(Harfbuzz TARGET harfbuzz::harfbuzz)
    link_package(ICU_i18n)

    if(SDL2_FOUND AND OPENGL_FOUND AND UNIX)
        # SDL2 dynamically loads OpenGL if needed, so do not link to OpenGL when
        # on Linux. For Windows, we need to link to OpenGL as we also have a win32
        # driver using it.
        add_definitions(-DWITH_OPENGL)
        message(STATUS "OpenGL found -- -DWITH_OPENGL -- (via SDL2)")
    else()
        link_package(OpenGL TARGET OpenGL::GL)
    endif()
endif()

include(3rdparty/llvm/CheckAtomic)

if(APPLE)
    link_package(Iconv TARGET Iconv::Iconv)

    target_link_libraries(openttd_lib
        ${AUDIOTOOLBOX_LIBRARY}
        ${AUDIOUNIT_LIBRARY}
        ${COCOA_LIBRARY}
        ${QUARTZCORE_LIBRARY}
    )

    add_definitions(
        -DWITH_COCOA
    )
endif()

if(EMSCRIPTEN)
    add_library(WASM::WASM INTERFACE IMPORTED)

    # Allow heap-growth, and start with a bigger memory size.
    target_link_libraries(WASM::WASM INTERFACE "-s ALLOW_MEMORY_GROWTH=1")
    target_link_libraries(WASM::WASM INTERFACE "-s INITIAL_MEMORY=33554432")
    target_link_libraries(WASM::WASM INTERFACE "-s DISABLE_EXCEPTION_CATCHING=0")
    target_link_libraries(WASM::WASM INTERFACE "-s WASM_BIGINT")
    add_definitions(-s DISABLE_EXCEPTION_CATCHING=0)

    # Export functions to Javascript.
    target_link_libraries(WASM::WASM INTERFACE "-s EXPORTED_FUNCTIONS='[\"_main\", \"_em_openttd_add_server\"]' -s EXPORTED_RUNTIME_METHODS='[\"cwrap\"]'")

    # Preload all the files we generate during build.
    # As we do not compile with FreeType / FontConfig, we also have no way to
    # render several languages (like Chinese, ..), so where do you draw the
    # line what languages to include and which not? In the end, especially as
    # the more languages you add the slower downloading becomes, we decided to
    # only ship the English language.
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_BINARY_DIR}/baseset@/baseset")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_BINARY_DIR}/lang/english.lng@/lang/english.lng")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_SOURCE_DIR}/bin/ai@/ai")
    target_link_libraries(WASM::WASM INTERFACE "--preload-file ${CMAKE_SOURCE_DIR}/bin/game@/game")
    # Documentation files for the in-game text file viewer

=== bin/CMakeLists.txt ===
add_subdirectory(ai)
add_subdirectory(game)

=== media/CMakeLists.txt ===
add_subdirectory(baseset)

add_library(media
        INTERFACE
)
add_library(openttd::media ALIAS media)

if(NOT UNIX OR APPLE)
    return()
endif()

set(MEDIA_PNG_SOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.16.png
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.32.png
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.48.png
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.64.png
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.128.png
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.256.png
)

# Walk over all the png files, and generate a command to copy them
foreach(MEDIA_PNG_SOURCE_FILE IN LISTS MEDIA_PNG_SOURCE_FILES)
        get_filename_component(MEDIA_PNG_FILE_NAME "${MEDIA_PNG_SOURCE_FILE}" NAME)
        string(REGEX REPLACE "[^.]+.([0-9]*).*" "${CMAKE_CURRENT_BINARY_DIR}/icons/hicolor/\\1x\\1/apps/${BINARY_NAME}.png" MEDIA_PNG_BINARY_FILE "${MEDIA_PNG_FILE_NAME}")

        add_custom_command(OUTPUT ${MEDIA_PNG_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${MEDIA_PNG_SOURCE_FILE}
                    ${MEDIA_PNG_BINARY_FILE}
            MAIN_DEPENDENCY ${MEDIA_PNG_SOURCE_FILE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Copying ${MEDIA_PNG_FILE_NAME} file"
        )

        list(APPEND MEDIA_BINARY_FILES ${MEDIA_PNG_BINARY_FILE})
endforeach()

set(MEDIA_XPM_SOURCE_FILES
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.32.xpm
        ${CMAKE_CURRENT_SOURCE_DIR}/openttd.64.xpm
)

# Walk over all the xpm files, and generate a command to copy them
foreach(MEDIA_XPM_SOURCE_FILE IN LISTS MEDIA_XPM_SOURCE_FILES)
        get_filename_component(MEDIA_XPM_FILE_NAME "${MEDIA_XPM_SOURCE_FILE}" NAME)
        get_filename_component(MEDIA_XPM_FILE_EXT "${MEDIA_XPM_FILE_NAME}" EXT)
        set(MEDIA_XPM_BINARY_FILE "${CMAKE_CURRENT_BINARY_DIR}/pixmaps/${BINARY_NAME}${MEDIA_XPM_FILE_EXT}")

        add_custom_command(OUTPUT ${MEDIA_XPM_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${MEDIA_XPM_SOURCE_FILE}
                    ${MEDIA_XPM_BINARY_FILE}
            MAIN_DEPENDENCY ${MEDIA_XPM_SOURCE_FILE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
            COMMENT "Copying ${MEDIA_XPM_FILE_NAME} file"
        )

        list(APPEND MEDIA_BINARY_FILES ${MEDIA_XPM_BINARY_FILE})
endforeach()

# Create a new target which copies media files
add_custom_target(media_files
        DEPENDS
        ${MEDIA_BINARY_FILES}
)

add_dependencies(media
        media_files
)

get_target_property(LANG_SOURCE_FILES language_files LANG_SOURCE_FILES)

set(DESKTOP_BINARY_NAME ${BINARY_NAME}.desktop)

add_custom_command_timestamp(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_BINARY_NAME}
        COMMAND ${CMAKE_COMMAND}
                -DDESKTOP_SOURCE_FILE=${CMAKE_CURRENT_SOURCE_DIR}/openttd.desktop
                -DDESKTOP_BINARY_FILE=${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_BINARY_NAME}
                -DBINARY_NAME=${BINARY_NAME}
                -P ${CMAKE_SOURCE_DIR}/cmake/scripts/Desktop.cmake
                --
                ${LANG_SOURCE_FILES}
        MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/openttd.desktop
        DEPENDS ${LANG_SOURCE_FILES}
                ${CMAKE_SOURCE_DIR}/cmake/scripts/Desktop.cmake
        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
        COMMENT "Generating desktop file"
)

# Create a new target which generates desktop file
add_custom_target_timestamp(desktop_file
        DEPENDS
        ${CMAKE_CURRENT_BINARY_DIR}/${DESKTOP_BINARY_NAME}
)

add_dependencies(media
        desktop_file
)

=== regression/CMakeLists.txt ===
    # Copy the regression configuration in a special folder, so all autogenerated
    # folders end up in the same place after running regression.
    add_custom_command(OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/regression.cfg
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${CMAKE_CURRENT_SOURCE_DIR}/regression.cfg
                    ${CMAKE_CURRENT_BINARY_DIR}/regression.cfg
            MAIN_DEPENDENCY ${CMAKE_CURRENT_SOURCE_DIR}/regression.cfg
            COMMENT "Copying regression.cfg regression file"
    )

    # Create a new target which copies all regression files
    # Subdirectory targets will add themselves as dependencies
    add_custom_target(regression_files
            ALL  # this is needed because 'make test' doesn't resolve dependencies, and otherwise this is never executed
            DEPENDS
            ${CMAKE_BINARY_DIR}/regression/regression.cfg
    )

    # Create a new target which runs the regression
    # Subdirectory targets will add themselves as dependencies
    add_custom_target(regression)

    add_subdirectory(regression)
    add_subdirectory(stationlist)

=== src/CMakeLists.txt ===
add_subdirectory(script)
add_subdirectory(settingsgen)
add_subdirectory(strgen)

if(OPTION_TOOLS_ONLY)
    return()
endif()

add_subdirectory(3rdparty)
add_subdirectory(ai)
add_subdirectory(blitter)
add_subdirectory(core)
add_subdirectory(fontcache)
add_subdirectory(game)
add_subdirectory(lang)
add_subdirectory(linkgraph)
add_subdirectory(misc)
add_subdirectory(music)
add_subdirectory(network)
add_subdirectory(os)
add_subdirectory(pathfinder)
add_subdirectory(saveload)
add_subdirectory(sound)
add_subdirectory(spriteloader)
add_subdirectory(table)
add_subdirectory(tests)
add_subdirectory(timer)
add_subdirectory(video)
add_subdirectory(widgets)

add_files(
    viewport_sprite_sorter_sse4.cpp
    CONDITION SSE_FOUND
)

add_files(
    gfx_layout_icu.cpp
    gfx_layout_icu.h
    CONDITION ICU_i18n_FOUND AND HARFBUZZ_FOUND
)

add_files(
    aircraft.h
    aircraft_cmd.cpp
    aircraft_cmd.h
    aircraft_gui.cpp
    airport.cpp
    airport.h
    airport_cmd.h
    airport_gui.cpp
    animated_tile.cpp
    animated_tile_func.h
    articulated_vehicles.cpp
    articulated_vehicles.h
    autoreplace.cpp
    autoreplace_base.h
    autoreplace_cmd.cpp
    autoreplace_cmd.h
    autoreplace_func.h
    autoreplace_gui.cpp
    autoreplace_gui.h
    autoreplace_type.h
    autoslope.h
    base_consist.cpp
    base_consist.h
    base_media_base.h
    base_media_func.h
    base_station_base.h
    bitmap_type.h
    bmp.cpp
    bmp.h
    bootstrap_gui.cpp
    bridge.h
    bridge_gui.cpp
    bridge_map.cpp
    bridge_map.h
    build_vehicle_gui.cpp
    cargo_type.h
    cargoaction.cpp
    cargoaction.h
    cargomonitor.cpp
    cargomonitor.h
    cargopacket.cpp
    cargopacket.h
    cargotype.cpp
    cargotype.h
    cheat.cpp
    cheat_func.h
    cheat_gui.cpp
    cheat_type.h
    clear_cmd.cpp
    clear_func.h
    clear_map.h
    command.cpp
    command_func.h
    command_type.h
    company_base.h
    company_cmd.cpp
    company_cmd.h
    company_func.h
    company_gui.cpp
    company_gui.h
    company_manager_face.h
    company_type.h
    console.cpp
    console_cmds.cpp
    console_func.h
    console_gui.cpp
    console_gui.h
    console_internal.h
    console_type.h
    cpu.cpp
    cpu.h
    crashlog.cpp
    crashlog.h
    currency.cpp
    currency.h
    date_gui.cpp
    date_gui.h
    debug.cpp
    debug.h
    dedicated.cpp
    depot.cpp
    depot_base.h
    depot_cmd.cpp
    depot_cmd.h
    depot_func.h
    depot_gui.cpp
    depot_map.h
    depot_type.h
    direction_func.h
    direction_type.h
    disaster_vehicle.cpp
    disaster_vehicle.h
    dock_cmd.h
    dock_gui.cpp
    driver.cpp
    driver.h
    economy.cpp
    economy_base.h
    economy_cmd.h
    economy_func.h
    economy_type.h
    effectvehicle.cpp
    effectvehicle_base.h
    effectvehicle_func.h
    elrail.cpp
    elrail_func.h
    engine.cpp
    engine_base.h
    engine_cmd.h
    engine_func.h
    engine_gui.cpp
    engine_gui.h
    engine_type.h
    error.h
    error.cpp
    error_func.h
    error_gui.cpp
    fileio.cpp
    fileio_func.h
    fileio_type.h
    fios.cpp
    fios.h
    fios_gui.cpp
    fontcache.cpp
    fontcache.h
    fontdetection.h
    framerate_gui.cpp
    framerate_type.h
    gamelog.cpp
    gamelog.h
    gamelog_internal.h
    genworld.cpp
    genworld.h
    genworld_gui.cpp
    gfx.cpp
    gfx_func.h
    gfx_layout.cpp
    gfx_layout.h
    gfx_layout_fallback.cpp
    gfx_layout_fallback.h
    gfx_type.h
    gfxinit.cpp
    gfxinit.h
    goal.cpp
    goal_base.h
    goal_cmd.h
    goal_gui.cpp
    goal_type.h
    graph_gui.cpp
    graph_gui.h
    ground_vehicle.cpp
    ground_vehicle.hpp
    group.h
    group_cmd.cpp
    group_cmd.h
    group_gui.cpp
    group_gui.h
    group_type.h
    gui.h
    heightmap.cpp
    heightmap.h
    help_gui.cpp
    help_gui.h
    highscore.cpp
    highscore.h
    highscore_gui.cpp
    hotkeys.cpp
    hotkeys.h
    house.h
    house_type.h
    industry.h
    industry_cmd.cpp
    industry_cmd.h
    industry_gui.cpp
    industry_map.h
    industry_type.h
    industrytype.h
    ini.cpp
    ini_load.cpp
    ini_type.h
    intro_gui.cpp
    landscape.cpp
    landscape.h
    landscape_cmd.h
    landscape_type.h
    language.h
    league_base.h
    league_cmd.h
    league_cmd.cpp
    league_gui.h
    league_gui.cpp
    league_type.h
    library_loader.h
    livery.h
    main_gui.cpp
    map.cpp
    map_func.h
    map_type.h
    misc.cpp
    misc_cmd.cpp
    misc_cmd.h
    misc_gui.cpp
    mixer.cpp
    mixer.h
    music.cpp
    music_gui.cpp
    newgrf.cpp
    newgrf.h
    newgrf_airport.cpp
    newgrf_airport.h
    newgrf_airporttiles.cpp
    newgrf_airporttiles.h
    newgrf_animation_base.h
    newgrf_animation_type.h
    newgrf_callbacks.h
    newgrf_canal.cpp
    newgrf_canal.h
    newgrf_cargo.cpp
    newgrf_cargo.h
    newgrf_class.h
    newgrf_class_func.h
    newgrf_commons.cpp
    newgrf_commons.h
    newgrf_config.cpp
    newgrf_config.h
    newgrf_debug.h
    newgrf_debug_gui.cpp
    newgrf_engine.cpp
    newgrf_engine.h
    newgrf_generic.cpp
    newgrf_generic.h
    newgrf_gui.cpp
    newgrf_house.cpp
    newgrf_house.h
    newgrf_industries.cpp
    newgrf_industries.h
    newgrf_industrytiles.cpp
    newgrf_industrytiles.h
    newgrf_object.cpp
    newgrf_object.h
    newgrf_profiling.cpp
    newgrf_profiling.h
    newgrf_properties.h
    newgrf_railtype.cpp
    newgrf_railtype.h
    newgrf_roadstop.cpp
    newgrf_roadstop.h
    newgrf_roadtype.cpp
    newgrf_roadtype.h
    newgrf_sound.cpp
    newgrf_sound.h
    newgrf_spritegroup.cpp
    newgrf_spritegroup.h
    newgrf_station.cpp
    newgrf_station.h
    newgrf_storage.cpp
    newgrf_storage.h
    newgrf_text.cpp
    newgrf_text.h
    newgrf_town.cpp
    newgrf_town.h
    newgrf_townname.cpp
    newgrf_townname.h
    news_cmd.h
    news_func.h
    news_gui.cpp
    news_gui.h
    news_type.h
    object.h
    object_base.h
    object_cmd.cpp
    object_cmd.h
    object_gui.cpp
    object_map.h
    object_type.h
    openttd.cpp
    openttd.h
    order_backup.cpp
    order_backup.h
    order_base.h
    order_cmd.cpp
    order_cmd.h
    order_func.h
    order_gui.cpp
    order_type.h
    osk_gui.cpp
    palette.cpp
    palette_func.h
    pbs.cpp
    pbs.h
    progress.cpp
    progress.h
    querystring_gui.h
    rail.cpp
    rail.h
    rail_cmd.cpp
    rail_cmd.h
    rail_gui.cpp
    rail_gui.h
    rail_map.h
    rail_type.h
    random_access_file.cpp
    random_access_file_type.h
    rev.h
    road.cpp
    road.h
    road_cmd.cpp
    road_cmd.h
    road_func.h
    road_gui.cpp
    road_gui.h
    road_internal.h
    road_map.cpp
    road_map.h
    road_type.h
    roadstop.cpp
    roadstop_base.h
    roadveh.h
    roadveh_cmd.cpp
    roadveh_cmd.h
    roadveh_gui.cpp
    safeguards.h
    screenshot_gui.cpp
    screenshot_gui.h
    screenshot.cpp
    screenshot.h
    settings.cpp
    settings_cmd.h
    settings_func.h
    settings_gui.cpp
    settings_gui.h
    settings_internal.h
    settings_table.h
    settings_table.cpp
    settings_type.h
    ship.h
    ship_cmd.cpp
    ship_cmd.h
    ship_gui.cpp
    signal.cpp
    signal_func.h
    signal_type.h
    signature.cpp
    signature.h
    signs.cpp
    signs_base.h
    signs_cmd.cpp
    signs_cmd.h
    signs_func.h
    signs_gui.cpp
    signs_type.h
    slope_func.h
    slope_type.h
    smallmap_gui.cpp
    smallmap_gui.h
    social_integration.cpp
    social_integration.h
    sortlist_type.h
    sound.cpp
    sound_func.h
    sound_type.h
    sprite.cpp
    sprite.h
    spritecache.cpp
    spritecache.h
    spritecache_internal.h
    station.cpp
    station_base.h
    station_cmd.cpp
    station_cmd.h
    station_func.h
    station_gui.cpp
    station_gui.h
    station_kdtree.h
    station_map.h
    station_type.h
    statusbar_gui.cpp
    statusbar_gui.h
    stdafx.h
    story.cpp
    story_base.h
    story_cmd.h
    story_gui.cpp
    story_type.h
    string.cpp
    string_base.h
    string_func.h
    string_type.h
    stringfilter.cpp
    stringfilter_type.h
    strings.cpp
    strings_func.h
    strings_internal.h
    strings_type.h
    subsidy.cpp
    subsidy_base.h
    subsidy_cmd.h
    subsidy_func.h
    subsidy_gui.cpp
    subsidy_type.h
    survey.cpp
    survey.h
    tar_type.h
    terraform_cmd.cpp
    terraform_cmd.h
    terraform_gui.cpp
    terraform_gui.h
    textbuf.cpp
    textbuf_gui.h
    textbuf_type.h
    texteff.cpp
    texteff.hpp
    textfile_gui.cpp
    textfile_gui.h
    textfile_type.h
    tgp.cpp
    tgp.h
    thread.h
    tile_cmd.h
    tile_map.cpp
    tile_map.h
    tile_type.h
    tilearea.cpp
    tilearea_type.h
    tilehighlight_func.h
    tilehighlight_type.h
    tilematrix_type.hpp
    timetable.h
    timetable_cmd.cpp
    timetable_cmd.h
    timetable_gui.cpp
    toolbar_gui.cpp
    toolbar_gui.h
    town.h
    town_cmd.cpp
    town_cmd.h
    town_gui.cpp
    town_kdtree.h
    town_map.h
    town_type.h
    townname.cpp
    townname_func.h
    townname_type.h
    track_func.h
    track_type.h
    train.h
    train_cmd.cpp
    train_cmd.h
    train_gui.cpp
    transparency.h
    transparency_gui.cpp
    transparency_gui.h
    transport_type.h
    tree_cmd.cpp
    tree_cmd.h
    tree_gui.cpp
    tree_map.h
    tunnel_map.cpp
    tunnel_map.h
    tunnelbridge.h
    tunnelbridge_cmd.cpp
    tunnelbridge_cmd.h
    tunnelbridge_map.h
    vehicle.cpp
    vehicle_base.h
    vehicle_cmd.cpp
    vehicle_cmd.h
    vehicle_func.h
    vehicle_gui.cpp
    vehicle_gui.h
    vehicle_gui_base.h
    vehicle_type.h
    vehiclelist.cpp
    vehiclelist.h
    vehiclelist_cmd.h
    vehiclelist_func.h
    viewport.cpp
    viewport_cmd.h
    viewport_func.h
    viewport_gui.cpp
    viewport_kdtree.h
    viewport_sprite_sorter.h
    viewport_type.h
    void_cmd.cpp
    void_map.h
    water.h
    water_cmd.cpp
    water_cmd.h
    water_map.h
    waypoint.cpp
    waypoint_base.h
    waypoint_cmd.cpp
    waypoint_cmd.h
    waypoint_func.h
    waypoint_gui.cpp
    widget.cpp
    widget_type.h
    window.cpp
    window_func.h
    window_gui.h
    window_type.h
    zoom_func.h
    zoom_type.h
)

=== bin/ai/CMakeLists.txt ===
set(AI_COMPAT_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/compat_0.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.0.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.1.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.2.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.3.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.4.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.5.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.6.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.8.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.9.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.10.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.11.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_12.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_13.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_14.nut
)

foreach(AI_COMPAT_SOURCE_FILE IN LISTS AI_COMPAT_SOURCE_FILES)
    string(REPLACE "${CMAKE_SOURCE_DIR}/bin/" "" AI_COMPAT_SOURCE_FILE_NAME "${AI_COMPAT_SOURCE_FILE}")
    string(CONCAT AI_COMPAT_BINARY_FILE "${CMAKE_BINARY_DIR}/" "${AI_COMPAT_SOURCE_FILE_NAME}")

    add_custom_command(OUTPUT ${AI_COMPAT_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${AI_COMPAT_SOURCE_FILE}
                    ${AI_COMPAT_BINARY_FILE}
            MAIN_DEPENDENCY ${AI_COMPAT_SOURCE_FILE}
            COMMENT "Copying ${AI_COMPAT_SOURCE_FILE_NAME}"
    )

    list(APPEND AI_COMPAT_BINARY_FILES ${AI_COMPAT_BINARY_FILE})
endforeach()

# Create a new target which copies all compat files
add_custom_target(ai_compat_files
        DEPENDS ${AI_COMPAT_BINARY_FILES}
)

add_dependencies(openttd
    ai_compat_files
)

=== bin/game/CMakeLists.txt ===
set(GS_COMPAT_SOURCE_FILES
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.2.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.3.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.4.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.5.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.6.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.7.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.8.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.9.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.10.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_1.11.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_12.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_13.nut
	${CMAKE_CURRENT_SOURCE_DIR}/compat_14.nut
)

foreach(GS_COMPAT_SOURCE_FILE IN LISTS GS_COMPAT_SOURCE_FILES)
    string(REPLACE "${CMAKE_SOURCE_DIR}/bin/" "" GS_COMPAT_SOURCE_FILE_NAME "${GS_COMPAT_SOURCE_FILE}")
    string(CONCAT GS_COMPAT_BINARY_FILE "${CMAKE_BINARY_DIR}/" "${GS_COMPAT_SOURCE_FILE_NAME}")

    add_custom_command(OUTPUT ${GS_COMPAT_BINARY_FILE}
            COMMAND ${CMAKE_COMMAND} -E copy
                    ${GS_COMPAT_SOURCE_FILE}
                    ${GS_COMPAT_BINARY_FILE}
            MAIN_DEPENDENCY ${GS_COMPAT_SOURCE_FILE}
            COMMENT "Copying ${GS_COMPAT_SOURCE_FILE_NAME}"
    )

    list(APPEND GS_COMPAT_BINARY_FILES ${GS_COMPAT_BINARY_FILE})
endforeach()

# Create a new target which copies all compat files
add_custom_target(gs_compat_files
        DEPENDS ${GS_COMPAT_BINARY_FILES}
)

add_dependencies(openttd
    gs_compat_files
)

=== regression/regression/CMakeLists.txt ===
include(CreateRegression)
create_regression(
    ${CMAKE_CURRENT_SOURCE_DIR}/info.nut
    ${CMAKE_CURRENT_SOURCE_DIR}/main.nut
    ${CMAKE_CURRENT_SOURCE_DIR}/require.nut
    ${CMAKE_CURRENT_SOURCE_DIR}/result.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/test.sav
)

=== regression/stationlist/CMakeLists.txt ===
include(CreateRegression)
create_regression(
    ${CMAKE_CURRENT_SOURCE_DIR}/info.nut
    ${CMAKE_CURRENT_SOURCE_DIR}/main.nut
    ${CMAKE_CURRENT_SOURCE_DIR}/result.txt
    ${CMAKE_CURRENT_SOURCE_DIR}/test.sav
)

=== src/3rdparty/CMakeLists.txt ===
add_subdirectory(catch2)
add_subdirectory(fmt)
add_subdirectory(icu)
add_subdirectory(md5)
add_subdirectory(monocypher)
add_subdirectory(squirrel)
add_subdirectory(nlohmann)
add_subdirectory(opengl)
add_subdirectory(openttd_social_integration_api)

=== src/ai/CMakeLists.txt ===
add_files(
    ai.hpp
    ai_config.cpp
    ai_config.hpp
    ai_core.cpp
    ai_gui.cpp
    ai_gui.hpp
    ai_info.cpp
    ai_info.hpp
    ai_instance.cpp
    ai_instance.hpp
    ai_scanner.cpp
    ai_scanner.hpp
)

=== src/blitter/CMakeLists.txt ===
add_files(
    32bpp_anim.cpp
    32bpp_anim.hpp
    32bpp_base.cpp
    32bpp_base.hpp
    32bpp_optimized.cpp
    32bpp_optimized.hpp
    32bpp_simple.cpp
    32bpp_simple.hpp
    8bpp_base.cpp
    8bpp_base.hpp
    8bpp_optimized.cpp
    8bpp_optimized.hpp
    8bpp_simple.cpp
    8bpp_simple.hpp
    CONDITION NOT OPTION_DEDICATED
)

add_files(
    32bpp_anim_sse2.cpp
    32bpp_anim_sse2.hpp
    32bpp_anim_sse4.cpp
    32bpp_anim_sse4.hpp
    32bpp_sse2.cpp
    32bpp_sse2.hpp
    32bpp_sse4.cpp
    32bpp_sse4.hpp
    32bpp_sse_func.hpp
    32bpp_sse_type.h
    32bpp_ssse3.cpp
    32bpp_ssse3.hpp
    CONDITION NOT OPTION_DEDICATED AND SSE_FOUND
)

add_files(
    40bpp_anim.cpp
    40bpp_anim.hpp
    CONDITION NOT OPTION_DEDICATED AND OPENGL_FOUND
)

add_files(
    base.hpp
    common.hpp
    factory.hpp
    null.cpp
    null.hpp
)

=== debian/changelog ===
openttd (14.1-2) unstable; urgency=medium

  * [10c3c48] Backport upstream patch to fix FTBFS. Thanks to Adrian Bunk
    for finding the patch to backport (Closes: #1114246)
  * [4e21b06] Bump standards version to 4.7.2 (no changes required)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 08 Oct 2025 20:15:53 +0200

openttd (14.1-1) unstable; urgency=medium

  * [2866976] New upstream release 14.1
  * [85c36bb] Build-depend on libcurl
  * [ec43535] Make copyright file complete again (Closes: #1070208)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 25 Jun 2024 11:16:23 +0200

openttd (14.0-1) unstable; urgency=medium

  * [0aebd19] New upstream release 14.0
  * [05088dc] Bump standards version to 4.7.0 (no changes required)
  * [94283f5] Build-depend on harfbuzz, support right-to-left text
  * [c8517b8] Remove rtl-language-message patch

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 24 Apr 2024 10:35:44 +0200

=== debian/control ===
Source: openttd
Section: games
Priority: optional
Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
Uploaders: Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper-compat (= 13), libsdl2-dev, zlib1g-dev, libpng-dev,
 libfreetype-dev, libfontconfig-dev, libicu-dev, liblzo2-dev, liblzma-dev,
 libfluidsynth-dev, libopengl-dev, libharfbuzz-dev,
 libcurl4-openssl-dev | libcurl-dev,
 grfcodec, openttd-opengfx,
 cmake
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/openttd-team/openttd
Vcs-Git: https://salsa.debian.org/openttd-team/openttd.git
Homepage: https://www.openttd.org/
Rules-Requires-Root: no

Package: openttd
Architecture: any
Multi-Arch: no
Depends: ${shlibs:Depends}, ${misc:Depends}, openttd-data (= ${source:Version})
Recommends: openttd-opengfx, openttd-openmsx, openttd-opensfx
Suggests: timidity
Description: reimplementation of Transport Tycoon Deluxe with enhancements
 OpenTTD is a reimplementation of the Microprose game "Transport
 Tycoon Deluxe" with lots of new features and enhancements.
 .
 OpenTTD is playable with the free graphics files from the openttd-opengfx
 package and optional sound and music files from the openttd-opensfx and
 openttd-openmsx packages Alternatively, OpenTTD can use the graphics files
 from the original Transport Tycoon Deluxe game (See README.Debian on how to set
 this up).

Package: openttd-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: common data files for the OpenTTD game
 This package contains data files like language files, scripts and some
 auxiliary graphics.  It does not include any full graphics or sound sets,
 which still need to be installed separately to play OpenTTD.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile to build the openttd debian package.

include /usr/share/dpkg/architecture.mk

# Use debhelper default for all targets (but some are overridden below).
%:
	dh $@ --buildsystem=cmake

# This prevents linking uselessly to libicudata and silences a warning
# in the build process.
export DEB_LDFLAGS_MAINT_APPEND=-Wl,-as-needed

# Enable all hardening options (since openttd offers a network-listening
# service that handles untrusted data).
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Build release
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_BUILD_TYPE=RelWithDebInfo
# Explicitly mark dependencies as required or disabled, so an issue with
# build dependencies does not silently remove a feature or add a
# dependency
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_ZLIB=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_LibLZMA=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_LZO=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_PNG=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Freetype=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_SDL2=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Fontconfig=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_ICU=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Grfcodec=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Fluidsynth=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_OpenGL=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_Harfbuzz=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_REQUIRE_FIND_PACKAGE_CURL=TRUE
# Signal FindCURL.cmake to not look for libcurl-supplied .cmake files,
# since these do not (currently) exist. FindCURL uses find_package in
# config mode to find these files and is intended to fall back to using
# pkg-config if not found, but because we made CURL required (which
# applies to the find_package in module mode in OpenTTD's cmakelists.txt
# that loads FindCURL.cmake, but also applies to the find_package in
# config mode used by FindCURL.cmake), this fallback breaks and finding
# CURL is aborted right away. By explicitly skipping this config-mode
# search, CURL can be found as expected.
CMAKE_CONFIG_ARGUMENTS += -DCURL_NO_CURL_CMAKE=TRUE
CMAKE_CONFIG_ARGUMENTS += -DCMAKE_DISABLE_FIND_PACKAGE_Allegro=TRUE

# When crosscompiling, prebuild tools that need to run on the build
# machine in a different build directory, and pass that build directory
# to the regular build so it can use those brebuilt ones.
ifneq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
TOOLS_DIR=$(CURDIR)/build-native
CMAKE_CONFIG_ARGUMENTS += "-DHOST_BINARY_DIR=$(TOOLS_DIR)"
endif

# Pass custom options to configure. Since it's not autoconf but a custom
# script, some of the option names are slightly different. We also need
# to be explicit about the dependencies, in case we're not running in a
# clean build root.
override_dh_auto_configure:
ifneq ($(TOOLS_DIR),)
	dpkg-architecture -a"$(DEB_BUILD_ARCH)" -f -c dh_auto_configure -B"$(TOOLS_DIR)" -- -DOPTION_TOOLS_ONLY=ON
endif
	dh_auto_configure -- $(CMAKE_CONFIG_ARGUMENTS)

override_dh_auto_build:
ifneq ($(TOOLS_DIR),)
	dpkg-architecture -a"$(DEB_BUILD_ARCH)" -f -c dh_auto_build -B"$(TOOLS_DIR)"
endif
	dh_auto_build

execute_after_dh_install-arch:
	# Prevent installing duplicate license file
	rm debian/openttd/usr/share/doc/openttd/COPYING.md

GRF=media/baseset/openttd.grf
GRF_BACKUP=debian/openttd.grf

execute_before_dh_auto_build:
	# Remove the prebuilt grf file, to force a rebuild from source
	# (but do keep a backup, so the clean rule can restore it as
	# required by the policy).
	[ -f "$(GRF_BACKUP)" ] || mv "$(GRF)" "$(GRF_BACKUP)"

execute_after_dh_auto_clean:
	[ ! -f "$(GRF_BACKUP)" ] || mv "$(GRF_BACKUP)" "$(GRF)"

=== debian/watch ===
version=4

https://www.openttd.org/downloads/openttd-releases/latest .*/openttd-(\d.*)-source\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
